From Bignums.BigZ
Require Import BigZ.
Require Import List.
Require Import FOLib.
Require Import FOCompil FOReify.
Require Import Instancemathcomp.
Set Asymmetric Patterns.
Require Import mathcomp.ssreflect.ssreflect.
From mathcomp
     Require Import ssrfun ssrbool eqtype ssrnat div.

(** Declared operators *)

(* Constants *)
(* Instance Tcomparison : DeclOperator.t := @DeclOperator.Mk comparison (Eq :: Lt :: Gt :: nil).

Instance Tpositive : DeclOperator.t := @DeclOperator.Mk positive (xH :: nil). *)

Instance Tbool : DeclOperator.t := @DeclOperator.Mk bool (true :: false :: nil).

Instance Tnat : DeclOperator.t := @DeclOperator.Mk nat (O :: nil).

Instance Tprop : DeclOperator.t := @DeclOperator.Mk Prop (True :: False :: nil).

Instance TZ  : DeclOperator.t := @DeclOperator.Mk _ (Z0 :: 1%Z::nil).

(*Instance TN  : DeclOperator.t := @DeclOperator.Mk _ (N0 :: nil).

Instance TbigZ  : DeclOperator.t := @DeclOperator.Mk bigZ (BigZ.zero :: BigZ.one :: nil) . *)

(* Unary *)

Instance Tnat_nat : DeclOperator.t := @DeclOperator.Mk _ (S :: (*Nat.sqrt ::*) ssrnat.predn :: ssrnat.half :: ssrnat.uphalf :: nil).

Instance Tnat_Z   : DeclOperator.t := @DeclOperator.Mk _ (Z.of_nat :: nil).

(*Instance Tnat_pos : DeclOperator.t := @DeclOperator.Mk _ (Pos.of_succ_nat :: Pos.of_nat :: nil).*)

(*Instance Tpos_nat : DeclOperator.t := @DeclOperator.Mk _ (Pos.to_nat :: nil).*)

(*Instance TZ_nat   : DeclOperator.t := @DeclOperator.Mk _ (Z.to_nat :: nil).*)

(*Instance TZ_pos   : DeclOperator.t := @DeclOperator.Mk _ (Z.to_pos :: nil).*)

Instance Tbool_bool : DeclOperator.t := @DeclOperator.Mk _ (negb :: nil).

Instance Tbool_bool_bool : DeclOperator.t := @DeclOperator.Mk _ (andb :: orb :: implb :: nil).

Instance Tbool_prop : DeclOperator.t := @DeclOperator.Mk _ (is_true :: nil).

Instance Tprop_prop : DeclOperator.t := @DeclOperator.Mk _ (not :: nil).

(*Instance Tpos_Z : DeclOperator.t := @DeclOperator.Mk _ (Z.pos :: Z.neg :: nil).

Instance Tpos_N : DeclOperator.t := @DeclOperator.Mk _ (N.pos :: nil).

Instance Tpos_pos : DeclOperator.t := @DeclOperator.Mk _ (Pos.succ :: Pos.pred :: xI :: xO :: nil).
*)

Instance TZ_Z : DeclOperator.t := 
  @DeclOperator.Mk _ ((*Z.opp ::*) Z.succ :: (*Z.sqrt :: Z.sgn :: Z.abs :: Zpos_of_nat ::*) uphalfZ ::  nil ).
(*
Instance TN_N : DeclOperator.t := 
  @DeclOperator.Mk _ (N.succ :: nil ).

Instance TbigZ_Z : DeclOperator.t :=
  @DeclOperator.Mk (bigZ → Z) (BigZ.to_Z :: nil).

Instance TZ_bigZ : DeclOperator.t :=
  @DeclOperator.Mk (Z → bigZ) (BigZ.of_Z :: nil).

Instance TbigZ_bigZ : DeclOperator.t :=
  @DeclOperator.Mk (bigZ → bigZ) (BigZ.opp :: nil).
*)
(* Binary *)

Instance Tnat_nat_nat : DeclOperator.t := 
  @DeclOperator.Mk _ 
                   ((*Nat.pow ::*) plus :: minus :: ssrnat.subn ::(*max ::*) mult :: ssrnat.muln (*Nat.div :: Nat.modulo ::*) :: ssrnat.expn ::

                                        ssrnat.maxn :: ssrnat.minn :: divn :: modn :: gcdn :: lcmn :: nil).

Instance TZ_Z_Z : DeclOperator.t := 
  @DeclOperator.Mk _
                   (Z.pow :: Zplus :: Zminus :: Zmult :: Z.max :: Z.min
                          :: Z.div :: Z.gcd :: Z.lcm :: (*Zmod :: Z.quot :: Z.rem ::*) nil ).

(*Instance TN_N_N : DeclOperator.t := 
  @DeclOperator.Mk _ 
                   (N.pow :: N.add :: N.sub :: N.mul :: N.div :: nil).

Instance TZ_pos_Z : DeclOperator.t := @DeclOperator.Mk _ (Z.pow_pos :: nil).  
 *)

Instance TZ_Z_prop : DeclOperator.t :=  @DeclOperator.Mk _ (Z.le :: Z.lt :: Z.ge :: Z.gt :: Z.divide :: nil).

(*Instance TZ_Z_bool : DeclOperator.t :=  @DeclOperator.Mk _ (Z.eq_bool :: Z.eqb :: Z.leb :: Z.ltb :: Z.geb :: Z.gtb :: nil). *)

(*Instance TZ_Z_cmp : DeclOperator.t :=  @DeclOperator.Mk _ (Zcompare :: nil). *)

Instance Tnat_nat_bool : DeclOperator.t :=  
  @DeclOperator.Mk _ 
                   (ssrnat.eqn :: ssrnat.leq :: dvdn :: nil).

(*Instance Tpos_pos_prop : DeclOperator.t :=  
  @DeclOperator.Mk _ (Ple :: Plt :: Pge :: Pgt ::nil).

Instance Tpos_pos_pos : DeclOperator.t :=
  @DeclOperator.Mk _ (Pplus :: Pos.add_carry :: Pminus :: Pmult :: Pmax :: Pos.min :: nil).
*)

(*Instance Tnat_nat_prop : DeclOperator.t :=  
  @DeclOperator.Mk _ (ge :: le :: lt :: gt :: nil).

Instance TN_N_prop : DeclOperator.t :=  @DeclOperator.Mk _ (N.le :: nil).
 *)

Instance Tprop_prop_prop : DeclOperator.t := @DeclOperator.Mk _ (or :: nil).

(*Instance TbigZ_bigZ_prop : DeclOperator.t :=
  @DeclOperator.Mk (bigZ → bigZ → Prop) (BigZ.eq :: BigZ.lt :: nil).

Instance TbigZ_bigZ_bool : DeclOperator.t :=
  @DeclOperator.Mk (bigZ → bigZ → bool) (BigZ.eqb :: BigZ.leb :: BigZ.ltb :: nil).

Instance TbigZ_bigZ_bigZ : DeclOperator.t :=
  @DeclOperator.Mk (bigZ → bigZ → bigZ)
    (BigZ.add :: BigZ.sub :: BigZ.mul :: BigZ.div :: BigZ.min :: BigZ.max :: nil).
*)
Existing Instances ReifyType.MakeProp ReifyType.MakeBtype ReifyType.MakeArrow.

(** Declared types *)
Definition declTypes := (Z:Type) :: (bool:Type):: (nat:Type)  :: nil.

Inductive btyp_u : Type := | bt_Z | bt_bool | bt_nat. 

Scheme Equality for btyp_u.

Definition declStypes : list btyp_u := bt_Z :: bt_bool :: bt_nat :: nil.


Definition max_typ := 3.

(* Register using type classes *)

Instance EqBtyp_u : EqTest.t btyp_u.
Proof.
  apply (EqTest.Mk btyp_u_beq).
  destruct t1 ; destruct t2 ; simpl ; intuition congruence.
Defined.

(* Map each type in declTypes to an element in declStypes *)
Lemma reify_btypes : Hlist.t (fun x => @MkName.t Type btyp_u (fst x) (snd x)) (List.combine declTypes declStypes).
Proof. reify_seq. Defined.

(** Register btyp_u *)
Lemma register_btyp : True.
Proof.
  MkName.enum declStypes.
Defined.

(** Bind btyp_u with Type *)
Require Import FOLType.

Einstance.

Definition etyp_u : btyp_u -> Type.
Proof.  mk_etyp. Defined.

(** Compute the types required by declared operators *)

Definition styp := (list (option btyp_u) * option btyp_u)%type.

Definition operator_types : list styp.
Proof.
  operator_types btyp_u etyp_u declStypes 3.
Defined.

Lemma reify_operator_types : Hlist.t (fun x => @MkName.t _ _ (eval_my_typ _ etyp_u x) x) operator_types.
Proof. reify_seq. Defined.


Lemma number_types : Hlist.t (fun x => @MkName.t _ _ (fst x) (snd x)) (@MkName.mapi _ _ (fun x p => (x,p)) operator_types).
Proof. reify_seq. Defined.                                                            

Einstance.

Lemma reify_operators : True.
Proof. reify_operators operator_types. Defined.

Einstance.

Notation user_op := (positive * positive)%type.


Definition dump : btyp_u -> positive.
Proof. make_dump. Defined.

Definition parse : positive -> btyp_u * positive.
Proof. make_parse declStypes. Defined.

Lemma parse_dump : forall bt p, parse (concat (dump bt) p) = (bt,p).
Proof. parse_dump. Qed.


Definition inj_typ : btyp_u ->  option btyp_u.
Proof. mk_inj_typ. Defined.

Require Import FOReify.

Definition equi_typ_u (bt:btyp_u) : etyp_u bt -> etyp_u bt -> Prop.
Proof.  equi_typ etyp_u bt. Defined.

Definition inj_cst (bt : btyp_u) : etyp_u bt -> Btyp.etyp_prop etyp_u (inj_typ bt).
Proof.
  inj_cst etyp_u bt.
Defined.

Definition dtyp : forall (bt:btyp_u), etyp_u bt.
Proof. intro bt ; dtyp etyp_u bt. Defined.

Instance Btyp : Btyp.t btyp_u.
Proof.
apply Btyp.Mk with (etyp := etyp_u) (inj_typ := inj_typ) (t_beq := btyp_u_beq) (equi_typ := equi_typ_u).
* apply (Parser.Mk dump parse).
  parse_dump.
* exact dtyp.
*  (intros t1 t2 ; destruct t1 ; destruct t2 ; simpl ; congruence).
* abstract (is_equi_typ etyp_u bt).
* exact inj_cst.
Defined.

Instance BtypPropI : BtypProp.t btyp_u := Make Btyp.
Import BtypProp.


Definition xop_args_u : user_op ->  list (option btyp_u).
Proof. mk_op_args_u btyp_u operator_types. Defined.

Definition op_args_u := Eval compute in xop_args_u.

Definition xop_ret_u : user_op ->  option btyp_u.
Proof. mk_op_ret_u btyp_u operator_types. Defined.

Definition op_ret_u := Eval compute in xop_ret_u.

Unset Ltac Debug.            

Transparent block.

Definition xop_eval_u : forall (o:user_op),  eval_typ etyp (op_args_u o) (op_ret_u o).
Proof. mk_op_eval_u btyp_u operator_types.
Defined.

Definition op_eval_u :=  Eval cbv beta iota zeta delta [xop_eval_u] in xop_eval_u.

(** Proving properties *)

Lemma op_is_morph :    forall o, is_morph BtypProp.etyp BtypProp.equi_typ (op_eval_u o).
Proof. make_morph btyp_u operator_types.
Defined.

Require Import FOSimpl.


Instance syntax_arg : TrmWithProp.Arg.t btyp_u (positive*positive):=
@TrmWithProp.Arg.Mk _  (positive*positive) op_args_u op_ret_u.
Require Import FOexpr.
Import TrmSyntax.


Instance syntax : TrmSyntax.t := 
  @TrmWithProp.MakeSyntax btyp_u _   syntax_arg etyp_u.
Canonical Structure syntax.
Import TrmSyntax.


Instance expr_sem : TrmSemantics.t syntax :=
  TrmWithProp.MakeSemantics syntax_arg _ op_eval_u equi_typ_u.
Canonical Structure expr_sem.
Import TrmSemantics.

Einstance.

Definition xinj_u : forall  (o:user_op), Hlist.t (Trm  positive) (List.map inj_typ  (TrmSyntax.op_args  (inr o))) -> Trm positive (inj_typ (op_ret (inr o))).
Proof.
  make_inj_u btyp_u etyp op op_eval_u operator_types.
Defined.


Definition inj_u  := Eval cbv beta iota zeta delta [xinj_u] in xinj_u.

Lemma inj_morph :
  forall (env : Make.Env Btyp syntax_arg positive) 
         (o : op) (l l' : Hlist.t (Trm positive) (List.map inj_typ (op_args o))),
    Hlist.equiv
      (fun (bt : btyp) (e1 e2 : Trm positive bt) =>
         equi_typ bt (interp env e1) (interp env e2)) l l' ->
    equi_typ (inj_typ (op_ret o)) (interp env (Make.inj inj_u o l))
             (interp env (Make.inj inj_u o l')).
Proof.
  make_inj_morph btyp_u operator_types.
Qed.



Definition xtype_cstr : forall (bt:btyp) (x:positive), option (Trm positive None).
Proof. 
  make_type_cstr btyp_u etyp  op. Defined.

Definition type_cstr := Eval cbv beta iota zeta delta [xtype_cstr] in xtype_cstr.

Lemma type_cstr_lem : 
  forall (bt : btyp) (v : positive) (e : Trm positive None)
         (env : Env (Make.expr_synt Btyp syntax_arg) positive),
    type_cstr bt v = Some e -> interp env e.
Proof. make_type_cstr_lem etyp. Qed.


Lemma inj_vars : 
    forall (o : op)
           (s : Hlist.t (Trm positive) (List.map BtypProp.inj_typ (op_args o)))
           (v : positive),
      In v (vars (Make.inj inj_u o s)) ->
      In v (Hlist.concat_map_list (vars (var:=positive)) s).
  Proof.
    make_inj_vars btyp_u operator_types.
  Qed.

  Lemma inj_cst_lem : 
    forall (env : Make.Env _ syntax_arg positive) 
           (o : op) (vls : Hlist.t etyp (op_args o)),
      equi_typ (BtypProp.inj_typ (op_ret o))
                    (BtypProp.inj_cst (op_ret o) (interp_seq vls (op_eval o)))
                    (interp env
                            (Make.inj inj_u o
                                       (Hlist.mapt (Make.inj_Cst Btyp syntax_arg positive) vls))).
  Proof.
    make_inj_cst_lem btyp_u etyp operator_types.
    
  Qed.

  Instance make_inj : 
    Make.spec inj_u type_cstr op_eval_u.
  Proof.
    constructor.
    apply inj_vars.
    apply inj_cst_lem.
    apply inj_morph.
    apply type_cstr_lem.
  Defined.

Require Import FOReify.



Definition xsimplify_op : forall (o:user_op), Make.simp_rule (inr o).
  make_simplify btyp_u etyp op operator_types.
Defined.

Definition simplify_op (o:op) : Make.simp_rule o :=
  match o with
    | inl _ => Make.Id _
    | inr o => xsimplify_op o
  end.



Lemma simplify_op_correct : 
   forall o : op,
   match simplify_op o with
   | Make.Unfold f =>
       forall (env : Env (Make.expr_synt Btyp syntax_arg) positive)
         (args : Hlist.t (Trm positive) (op_args o)),
       equi_typ (op_ret o) (interp env (f args)) (interp env (Op o args))
   | Make.Abstract l p =>
       forall (env : Env (Make.expr_synt Btyp syntax_arg) positive)
         (args : Hlist.t (Trm positive) (op_args o))
         (r : Trm positive (op_ret o)),
       equi_typ (op_ret o) (interp env (Op o args)) (interp env r) ->
       exists (args' : Hlist.t etyp l) , interp env (p r args (Hlist.map (fun bt c => Cst bt c) args'))
 | Make.Id => True
   end.
Proof.
  Unset Ltac Debug.
  make_simplify_correct btyp_u operator_types.
Defined.




Lemma simplify_var_correct : 
   forall o : op,
   match simplify_op o with
   | Make.Unfold f =>
       forall (args : Hlist.t (Trm positive) (op_args o)) (x : positive),
       In x (vars (f args)) <->
       In x (Hlist.concat_map_list (vars (var:=positive)) args)
   | Make.Abstract l p =>
     forall args res args', forall x, 
       In x (vars  (p res args args')) <-> 
       ((In x (vars  (Op o args))) \/ In x (vars res) \/ In x (Hlist.concat_map_list (@vars _ positive)  args'))
   | Make.Id => True
   end.
Proof.
  make_simplify_var_correct btyp_u operator_types.
Qed.


Lemma simplify_morph : 
     forall o : op,
   match simplify_op o with
   | Make.Unfold _ => True
   | Make.Abstract l p =>
       forall (r : Trm positive (op_ret o))
         (args : Hlist.t (Trm positive) (op_args o))
         (args1 args2 : Hlist.t (Trm positive) l)
         (env : Env (Make.expr_synt Btyp syntax_arg) positive),
       Hlist.equiv
         (fun (l0 : btyp) (v v' : Trm positive l0) =>
          equi_typ l0 (interp env v) (interp env v')) args1 args2 ->
       (interp env (p r args args1) <-> interp env (p r args args2))
   | Make.Id => True
   end.
Proof.
  make_simplify_morph btyp_u operator_types.
Qed.  

Instance simplifier : @Make.Simpl btyp_u _ _ syntax_arg op_eval_u.
  apply Make.MkS with (simplify_op := simplify_op).
  apply op_is_morph.
  apply simplify_op_correct.
  apply simplify_var_correct.
  apply simplify_morph.
Defined.

(** Check that tactics extract the right object *)

  Lemma get_btyp : exists ty, ty = btyp_u.
    let ty := btyp_u_of_inj make_inj 
    in exists ty.
              reflexivity.
  Defined.

  Lemma get_op : exists ty, ty = op.
    let bt := btyp_u_of_inj make_inj in
    let op := op_of_btyp_u bt in
    exists op.
           reflexivity.
  Defined.

  Lemma get_etyp : exists f , f = (@etyp _ ).
  Proof.
    let etyp_u := etyp_u_of_inj make_inj in
    let etyp := etyp_of_etyp_u etyp_u in
    exists etyp ; reflexivity.
  Qed.


  Lemma get_dtyp : exists f , f = dtyp.
    let f := dtyp_of_inj make_inj in
    exists f.
           reflexivity.
  Qed.

(*Global Opaque Z.pow_pos Pos.of_succ_nat Pos.of_nat Pos.to_nat Pos.succ Pplus Pminus Pmult. *)
(*Global Opaque Pmax Ppred beq_nat NPeano.leb NPeano.ltb Zeq_bool Z.leb Z.ltb Z.geb Z.gtb. *)
Global Opaque  Nat.pow. (*  NPeano.modulo minus  ge plus mult max NPeano.div *)
